#include <TimeLib.h>
#include <SPI.h>
#include <LiquidCrystal_PCF8574.h>

LiquidCrystal_PCF8574 lcd(0x27);

void setup() {
  lcd.begin(16, 2);
  lcd.setBacklight(true);
  lcd.clear();
  setSyncProvider(getTeensy3Time);

  lcd.print("Nowy Rok za:");
}

void loop() {
  if (Serial.available()) {
    time_t t = processSyncMessage();
    if (t != 0) {
      Teensy3Clock.set(t);
      setTime(t);
      Serial.println("Setting time");
    }
  }

  printTimeLeft();
  
  delay(1000);
}

time_t getTeensy3Time()
{
  return Teensy3Clock.get();
}

#define TIME_HEADER  "T"   // Header tag for serial time sync message

unsigned long processSyncMessage() {
  unsigned long pctime = 0L;
  const unsigned long DEFAULT_TIME = 1357041600; // Jan 1 2013 

  if(Serial.find(TIME_HEADER)) {
     pctime = Serial.parseInt();
     return pctime;
     if( pctime < DEFAULT_TIME) { // check the value is a valid time (greater than Jan 1 2013)
       pctime = 0L; // return 0 to indicate that the time is not valid
     }
  }
  return pctime;
}

void printTimeLeft() {
  lcd.setCursor(0,1);
  const time_t targetTimestamp = 1483228800;
  time_t timeLeft = targetTimestamp - now();
  
  int daysLeft = timeLeft / (60 * 60 * 24);
  timeLeft -= daysLeft * 60 * 60 * 24;

  int hoursLeft = timeLeft / (60 * 60);
  timeLeft -= hoursLeft * 60 * 60;

  int minutesLeft = timeLeft / 60;
  timeLeft -= minutesLeft * 60;
  
  lcd.print(daysLeft);
  lcd.print("d ");

  lcd.print(hoursLeft);
  lcd.print("h ");

  lcd.print(minutesLeft);
  lcd.print("m ");

  lcd.print(timeLeft);
  lcd.print("s     ");
}

